program ncepreadwrite 
!+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
implicit none
integer,  parameter :: iMax =  380
integer,  parameter :: jMax =  414
integer,  parameter :: Square2D = iMax*jMax
integer             :: i, j, ij
integer             :: days, Index, n
integer             :: ios

!---Topographie---
real,    parameter             :: LandDepth = 5.0
real,    dimension(jMax, iMax) :: Topo
logical, dimension(jMax, iMax) :: Land

!---Gitter---
!-----------------------------------------------
!nordrand liegt auf Phi0
!westrand liegt auf Lam0 
!-----------------------------------------------
real,    parameter    :: Phi0 =  60.3458
real,    parameter    :: Lam0 =  -4.0625
real,    parameter    :: dPhi =   0.025
real,    parameter    :: dLam =   0.04167

!---Lufttemperatur---
real, dimension(Square2D)   :: airTempV
real, dimension(jMax, iMax) :: airTemp 
real, dimension(iMax, jMax) :: airTempT

!+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
!-------------------------------------------
!---Topographie einlesen---
!
ios = 0
print *, 'open Topography !!!'
open (10, file = 'NSTopo.bin', form = 'unformatted', iostat=ios)
!read (10,iostat=ios,err=800,end=900) Topo
read (10) Topo
close (10)
print*, '***  Topo read from input file.'
print*, 'Topo(  1, 1) =', Topo(1,1)
print*, 'Topo(325,80) =', Topo(325,80)
!
!-------------------------------------------
!-------------------------------------------
!---Wasserpunkte bestimmen--- 
!
Land = (Topo < LandDepth)
ij   = count(.not. Land)

print *, '2-D    '
print *, ij 
!
!-------------------------------------------
!-------------------------------------------
!---Lufttemperaturdaten öffnen---
!
open(11, file   = 'AirT200301.direct' , &
         form   = 'unformatted'       , &
         status = 'old'               , &
         access = 'direct'            , &
         recl   = ij * 4)

open(21, file   = 'AirT200301-2D.direct', &
         form   = 'unformatted'       , &
         status = 'replace'           , &
         access = 'direct'            , &
         recl   = iMax * jMax * 4)
!-------------------------------------------
!-------------------------------------------
!---Lufttemperatur einlesen und schreiben---
!
days  = 31
Index = 4 * days + 1
do n = 1, Index
  read( 11, rec = n, iostat=ios ) airTempV( 1:ij )
  airTemp  = unpack( airTempV, .not. Land, 0.0 )
  airTempT = transpose( airTemp )
  write( 21, rec = n, iostat=ios ) airTempT
enddo
print*, '***  last data set: ', n-1
!
!-------------------------------------------
!-------------------------------------------
!---Lufttemperaturdaten öffnen---
close(11)
close(21)

end
